#include <stdio.h>
#include <conio.h>

int main()
{        
    char mask[2]={0};
    char byte;
    FILE *fin,*fout;
    fin = fopen("decompresso.dat","rb");

    if (!fin) {
		printf("Impossibile aprire decompresso.dat!");
		getch();
		return 1;
	}

    fout = fopen("compresso.dat","wb");
    
	if (!fout) {
		printf("Impossibile aprire compresso.dat!");
		getch();
		return 1;
	}
    
    printf("R-Type 2 Graphics Compressor (c) Syxtem/ev0 2004-2005\n");
    printf("Original Code by Syxtem modified by ev0\n");
    printf("ev0luzione@yahoo.it\n\n");
    
    int i,j,cont,ctmp;
    char c[16];
    
    c[0]=fgetc(fin);        // Legge il primo byte
 while (!feof(fin))
 {
	mask[0]=0;
	mask[1]=0;
    for (i=1;i<16;i++)
    {
        c[i]=fgetc(fin);    // Legge gli altri 15 byte
    }
    
    byte=c[0];  // Il byte pi usato  il primo letto
    ctmp=0;
    for (i=0;i<16;i++)  // Per ogni byte
    {
        cont=0;
        for (j=0;j<16;j++)  // Confronta ogni byte con gli altri
                            // se sono uguali, incrementa il contatore
        {
            if (c[j]==c[i]) cont+=1;
        }
        if (cont > ctmp)    // Se il contatore dell'ultimo byte letto  pi
                            // alto del precedente contatore pi alto, il
                            // nuovo contatore viene memorizzato e viene
                            // memorizzato il byte pi ripetuto
        {
            ctmp=cont;
            byte=c[i];
        }
    }

    //  byte: byte maggiore
    //  ctmp: n volte ripetuto

    for (i=0;i<7;i++)
    {
        if (c[i]!=byte)
			mask[0]=(mask[0]|0x80)>>1;
        else
			mask[0]=mask[0]>>1;
    }
        if (c[i]!=byte)
			mask[0]=(mask[0]|0x80);
        else
			mask[0]=mask[0];
			i++;
    for (i=8;i<15;i++)
    {
        if (c[i]!=byte)
			mask[1]=(mask[1]|0x80)>>1;
		else
			mask[1]=mask[1]>>1;
    }
        if (c[i]!=byte)
			mask[1]=(mask[1]|0x80);
        else
			mask[1]=mask[1];
			i++;

    //fwrite(&mask,1,sizeof(short int),fout); // Scrivi i due byte della mask
	fputc(mask[0],fout);
	fputc(mask[1],fout);
	mask[0]=0;
	mask[1]=0;
    fputc(byte,fout);                   // Scrivi il byte pi frequente
    for (i=0;i<16;i++)
    {
        if (byte!=c[i]) fputc(c[i],fout);   // Scrivi gli altri byte
    }

    
    c[0]=fgetc(fin); // Legge il primo byte necessario per far scattare il feof
 }
  fputc(0xFF,fout);
  fputc(0xFF,fout);
  fclose(fin);
  fclose(fout);
  
 printf("Compressione Finita");
 getch();
 return 0;
}
